import Qt 4.7
import "imports/XAComponents"
import "imports/XAComponents/date.js" as DateFunctions
import "imports/colibri"

Item {
    id: dtsEditor
    width: 560
    height: 420
    anchors.fill: parent

    property string windowTitle : qtInputTitle
    property string windowGotFocus : qtWindowGotFocus
    property string windowDisplaysItemOfType: qtItemType
    property string windowDisplaysItemWithUID: qtItemUID
    property string platformID: qtPlatformID

    property string dtsreview : qtInputDTSReview
    property string dtsreviewSQLDate : qtInputDTSReviewSQLDate
    property string dtsstart : qtInputDTSStart
    property string dtsstartSQLDate : qtInputDTSStartSQLDate
    property string dtsrepeat : qtInputDTSRepeat
    property string dtsrepeatHumanReadable : qtInputDTSRepeatHumanReadable
    property string dtsend : qtInputDTSEnd
    property string dtsendSQLDate : qtInputDTSEndSQLDate
    property string dtsdurationDays: qtInputDTSDurationDays
    property string dtsdurationHours: qtInputDTSDurationHours
    property string dtsdurationMinutes: qtInputDTSDurationMinutes
    property string dtsdurationHumandReadable: qtInputDTSDurationHumanReadable
    property string context : qtInputContext
    property string raciResponsible : qtInputRACIResponsible
    property string raciAccountible : qtInputRACIAccountible
    property string raciConsulted : qtInputRACIConsulted
    property string raciInformed : qtInputRACIInformed
    property int dtsSecurityLevel: qtInputSecurityLevel

    property bool fieldChange : false

    property int activeInputFieldID : 0

    signal contextAssignmentChanged();

    Keys.enabled: true
//    Keys.onCancelPressed: QtWindow.hide()
//    Keys.onEscapePressed: QtWindow.hide()
    Keys.onCancelPressed: QtHandler.CloseButtonClicked();
    Keys.onEscapePressed: QtHandler.CloseButtonClicked();
    Keys.onEnterPressed: {
        //console.debug("onEnterPressed")
        reviewAllDataForChanges()
    }

    onActiveFocusChanged: {
        //console.debug("QML++ onActiveFocusChanged")
    }

    onWindowDisplaysItemOfTypeChanged: {
        displayedItemTypeChanged();
    }

    function displayedItemTypeChanged() {
        //console.debug("QML++ onWindowDisplaysItemOfTypeChanged")
        //console.debug(windowDisplaysItemOfType)
        //console.debug(windowDisplaysItemWithUID)

        // load panel for item type
        // A = Action Item
        // All others are internal / No item selected

        if (windowDisplaysItemOfType == "A") {
            tabActionItemDetailsEditor.visible = true
            tabInternalDetailsEditor.visible = false

        } else {
            tabActionItemDetailsEditor.visible = false
            tabInternalDetailsEditor.visible = true
        }
    }

    onDtsrepeatChanged: {
        //framedTextInputRepeatDate.text = dtsEditor.dtsrepeat
        xaqmlrepeatdatepicker.dtsRepeatString = dtsEditor.dtsrepeat
    }

    onDtsrepeatHumanReadableChanged: {
        framedTextInputRepeatDate.text = dtsEditor.dtsrepeatHumanReadable
    }

    function activateFirstInputOnPanel() {
        //console.debug("QML++ AIActionDetailsInspector activateFirstInputOnPanel")

        setActiveInputFieldByID(0)
    }

    function reviewAllDataForChanges() {
        //QtHandler.ReviewDataChangedForField("context", framedTextInputContext.text)
        //        QtHandler.ReviewDataChangedForField("review_dt", framedTextInputReviewDate.text)
        //        QtHandler.ReviewDataChangedForField("start_dt", framedTextInputStartDate.text)
        //        QtHandler.ReviewDataChangedForField("repeat", framedTextInputRepeatDate.text)
        //        QtHandler.ReviewDataChangedForField("end_dt", framedTextInputDueDate.text)
        //        QtHandler.ReviewDataChangedForField("duration", framedTextInputDurationDate.text)
        //QtHandler.ReviewDataChangedForField("delegatedto", framedTextInputRACI_R.text)
        //QtHandler.ReviewDataChangedForField("task_owner", framedTextInputRACI_A.text)
        //QtHandler.ReviewDataChangedForField("consulted", framedTextInputRACI_C.text)
        //QtHandler.ReviewDataChangedForField("informonprogress", framedTextInputRACI_I.text)
    }

    function setDatePicker(d) {
        //console.debug(d.toString() + " --> " + d.getFullYear() + "-" + (d.getMonth()+1) + "-" + d.getDate())

        xaqmldatepicker.theYear = d.getFullYear()
        xaqmldatepicker.theMonth = d.getMonth()+1
        xaqmldatepicker.theDay = d.getDate()

        xaqmldatepicker.theTime = d.toLocaleTimeString()
    }

    function setDatePickerFromString(text) {
        var date = new Date()

        if (text == '') {
            xaqmldatepicker.enabled = false
        } else {
            date.setFullYear(parseInt(text.substr(0,4), 10), parseInt(text.substr(5,2), 10)-1, parseInt(text.substr(8,2), 10))
            date.setHours(parseInt(text.substr(11,2), 10))
            date.setMinutes(parseInt(text.substr(14,2), 10))
            date.setSeconds(parseInt(text.substr(17,2), 10))

            //console.debug("setDatePickerFromString")
            //console.debug(text)
            //console.debug(date.toGMTString())

            xaqmldatepicker.enabled = true
        }

        if (date == null) console.debug("date is null")
        else setDatePicker(date)
    }

    function setDurationPicker(days, hours, minutes) {
        if (days > 0 || hours > 0 || minutes > 0 ) {
            xaqmldurationpicker.theDays = days;
            xaqmldurationpicker.theHours = hours;
            xaqmldurationpicker.theMinutes = minutes;
            xaqmldurationpicker.enabled = true;
        } else {
            xaqmldurationpicker.enabled = false;
        }
    }

    function activateExtensionPanel(extensionid) {
        //console.debug("QML++ activateExtensionPanel")

        // 0 = xaqmladdressbookpicker
        // 1 = xaqmlrepeatdatepicker
        // 2 = xaqmldatepicker
        // 3 = xaqmldurationpicker

        var extensionOnOff = [false, false, false, false];
        extensionOnOff[extensionid] = true;

        xaqmladdressbookpicker.visible = extensionOnOff[0]
        xaqmlrepeatdatepicker.visible = extensionOnOff[1]
        xaqmldatepicker.visible = extensionOnOff[2]
        xaqmldurationpicker.visible = extensionOnOff[3]
    }

    function setActiveInputFieldByID(fieldid) {
        var activeColor = "#222222"
        var deactivatedColor = "#00000000"

        fieldChange = true

        // deactivate all
        framedTextInputContext.deactivateControl()
        framedTextInputReviewDate.deactivateControl()
        framedTextInputStartDate.deactivateControl()
        framedTextInputRepeatDate.deactivateControl()
        framedTextInputDueDate.deactivateControl()
        framedTextInputDurationDate.deactivateControl()

        framedTextInputRACI_R.deactivateControl()
        framedTextInputRACI_A.deactivateControl()
        framedTextInputRACI_C.deactivateControl()
        framedTextInputRACI_I.deactivateControl()


        // activate by fieldid
        if (fieldid == 0) {
            framedTextInputContext.activateControl()
            activateExtensionPanel(0)
        } else if (fieldid == 1) {
            framedTextInputReviewDate.activateControl()
            setDatePickerFromString(dtsreviewSQLDate)
            activateExtensionPanel(2)
        } else if (fieldid == 2) {
            framedTextInputStartDate.activateControl()
            setDatePickerFromString(dtsstartSQLDate)
            activateExtensionPanel(2)
        } else if (fieldid == 3) {
            framedTextInputRepeatDate.activateControl()
            activateExtensionPanel(1)
        } else if (fieldid == 4) {
            framedTextInputDueDate.activateControl()
            setDatePickerFromString(dtsendSQLDate)
            activateExtensionPanel(2)
        } else if (fieldid == 5) {
            framedTextInputDurationDate.activateControl()
            setDurationPicker(dtsdurationDays, dtsdurationHours, dtsdurationMinutes)
            activateExtensionPanel(3)
        } else if (fieldid == 6) {
            framedTextInputRACI_R.activateControl()
            activateExtensionPanel(0)
        } else if (fieldid == 7) {
            framedTextInputRACI_A.activateControl()
            activateExtensionPanel(0)
        } else if (fieldid == 8) {
            framedTextInputRACI_C.activateControl()
            activateExtensionPanel(0)
        } else if (fieldid == 9) {
            framedTextInputRACI_I.activateControl()
            activateExtensionPanel(0)
        }

        activeInputFieldID = fieldid

        fieldChange = false
    }

    Rectangle {
        id: windowRect
        color: "transparent"

        radius: 6
        smooth: true
        anchors.fill: parent
        anchors.rightMargin: (dtsEditor.platformID == "WIN" ? 1 : 0)
        anchors.bottomMargin: (dtsEditor.platformID == "WIN" ? 1 : 0)


        //
        // window title bar
        //

        XAWindowTitleBar {
            id: xaWindowTitleBar
            windowTitle: dtsEditor.windowTitle
            windowGotFocus: dtsEditor.windowGotFocus
            windowDrawBorder: (dtsEditor.platformID == "WIN")
        }


        Item {
            id: tabActionItemDetailsEditor
            anchors.fill: parent

            //
            // Context input frame
            //

            Rectangle {
                id: contextInputRect
                x: 0
                y: 28
                width: 300
                height: 45
                color: "#00000000"

                XAFramedTextInput {
                    id: framedTextInputContext
                    label: "Context:"
                    text: dtsEditor.context

                    anchors.left: parent.left
                    anchors.leftMargin: 20
                    anchors.top: parent.top
                    anchors.topMargin: 10
                    anchors.right: parent.right
                    anchors.rightMargin: -10

                    onFocusReceived: {
                        setActiveInputFieldByID(0)
                        QtHandler.setContextModelNeedsRefreshWithType("")
                    }
                }
            }


            //
            // dts input frame
            //

            Rectangle {
                id: dtsInputRect
                x: 0
                y: 68
                width: 300
                height: 35
                color: "#00000000"

                XAFramedTextInput {
                    id: framedTextInputReviewDate
                    label: "Next Review Date:"
                    text: dtsEditor.dtsreview

                    anchors.left: parent.left
                    anchors.leftMargin: 20
                    anchors.top: parent.top
                    anchors.topMargin: 15
                    anchors.right: parent.right
                    anchors.rightMargin: -10

                    onFocusReceived: setActiveInputFieldByID(1)
                }

                XAFramedTextInput {
                    id: framedTextInputStartDate
                    label: "Start Date:"
                    text: dtsEditor.dtsstart

                    anchors.left: parent.left
                    anchors.leftMargin: 20
                    anchors.top: parent.top
                    anchors.topMargin: 45
                    anchors.right: parent.right
                    anchors.rightMargin: -10

                    onFocusReceived: setActiveInputFieldByID(2)
                }

                XAFramedTextInput {
                    id: framedTextInputRepeatDate
                    label: "Repeat:"

                    anchors.left: parent.left
                    anchors.leftMargin: 20
                    anchors.top: parent.top
                    anchors.topMargin: 75
                    anchors.right: parent.right
                    anchors.rightMargin: -10

                    onFocusReceived: setActiveInputFieldByID(3)
                }

                XAFramedTextInput {
                    id: framedTextInputDueDate
                    label: "Due Date:"
                    text: dtsEditor.dtsend

                    anchors.left: parent.left
                    anchors.leftMargin: 20
                    anchors.top: parent.top
                    anchors.topMargin: 105
                    anchors.right: parent.right
                    anchors.rightMargin: -10

                    onFocusReceived: setActiveInputFieldByID(4)
                }

                XAFramedTextInput {
                    id: framedTextInputDurationDate
                    label: "Duration:"
                    text: dtsEditor.dtsdurationHumandReadable

                    anchors.left: parent.left
                    anchors.leftMargin: 20
                    anchors.top: parent.top
                    anchors.topMargin: 135
                    anchors.right: parent.right
                    anchors.rightMargin: -10

                    onFocusReceived: setActiveInputFieldByID(5)
                    //onTextChanged: QtHandler.ReviewDataChangedForField("duration", text)
                }
            }

            //
            // RACI input frame
            //

            Rectangle {
                id: raciInputRect
                x: 0
                y: 238
                width: 300
                height: 135
                color: "#00000000"

                XAFramedTextInput {
                    id: framedTextInputRACI_R
                    label: "Responsible:"
                    text: dtsEditor.raciResponsible

                    anchors.left: parent.left
                    anchors.leftMargin: 20
                    anchors.top: parent.top
                    anchors.topMargin: 10
                    anchors.right: parent.right
                    anchors.rightMargin: -10

                    onFocusReceived: {
                        setActiveInputFieldByID(6)
                        QtHandler.setContextModelNeedsRefreshWithType("R")
                    }
                }

                XAFramedTextInput {
                    id: framedTextInputRACI_A
                    label: "Accountable:"
                    text: dtsEditor.raciAccountible

                    anchors.left: parent.left
                    anchors.leftMargin: 20
                    anchors.top: parent.top
                    anchors.topMargin: 40
                    anchors.right: parent.right
                    anchors.rightMargin: -10

                    onFocusReceived: {
                        setActiveInputFieldByID(7)
                        QtHandler.setContextModelNeedsRefreshWithType("A")
                    }
                }

                XAFramedTextInput {
                    id: framedTextInputRACI_C
                    label: "Consulted:"
                    text: dtsEditor.raciConsulted

                    anchors.left: parent.left
                    anchors.leftMargin: 20
                    anchors.top: parent.top
                    anchors.topMargin: 70
                    anchors.right: parent.right
                    anchors.rightMargin: -10

                    onFocusReceived: {
                        setActiveInputFieldByID(8)
                        QtHandler.setContextModelNeedsRefreshWithType("C")
                    }
                }

                XAFramedTextInput {
                    id: framedTextInputRACI_I
                    label: "Informed:"
                    text: dtsEditor.raciInformed

                    anchors.left: parent.left
                    anchors.leftMargin: 20
                    anchors.top: parent.top
                    anchors.topMargin: 100
                    anchors.right: parent.right
                    anchors.rightMargin: -10

                    onFocusReceived: {
                        setActiveInputFieldByID(9)
                        QtHandler.setContextModelNeedsRefreshWithType("I")
                    }
                }

            }

            XASecurityLockButton {
                id: securityLockL0
                anchors.left: parent.left
                anchors.leftMargin: 5
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 5

                level: 0
                selected: (dtsSecurityLevel < 1) ? 1 : 0

                onClicked: QtHandler.ReviewDataChangedForField("protectionlevel", level)
            }
            XASecurityLockButton {
                id: securityLockL1
                anchors.left: parent.left
                anchors.leftMargin: 27
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 5

                level: 1
                selected: (dtsSecurityLevel == 1) ? 1 : 0

                onClicked: QtHandler.ReviewDataChangedForField("protectionlevel", level)
            }
            XASecurityLockButton {
                id: securityLockL2
                anchors.left: parent.left
                anchors.leftMargin: 49
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 5

                level: 2
                selected: (dtsSecurityLevel == 2) ? 1 : 0

                onClicked: QtHandler.ReviewDataChangedForField("protectionlevel", level)
            }
            XASecurityLockButton {
                id: securityLockL3
                anchors.left: parent.left
                anchors.leftMargin: 71
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 5

                level: 3
                selected: (dtsSecurityLevel == 3) ? 1 : 0

                onClicked: QtHandler.ReviewDataChangedForField("protectionlevel", level)
            }
            XASecurityLockButton {
                id: securityLockL4
                anchors.left: parent.left
                anchors.leftMargin: 93
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 5

                level: 4
                selected: (dtsSecurityLevel == 4) ? 1 : 0

                onClicked: QtHandler.ReviewDataChangedForField("protectionlevel", level)
            }
            XASecurityLockButton {
                id: securityLockL5
                anchors.left: parent.left
                anchors.leftMargin: 115
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 5

                level: 5
                selected: (dtsSecurityLevel == 5) ? 1 : 0

                onClicked: QtHandler.ReviewDataChangedForField("protectionlevel", level)
            }


            //
            // Date Picker
            //
            Rectangle {
                id: markerDatePickerRect
                anchors.left: parent.left
                anchors.leftMargin: 300
                anchors.top: parent.top
                anchors.topMargin: 22
                anchors.right: parent.right
                anchors.rightMargin: 10
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 5
                //height: 28
                color: "#222222"
                radius: 10
                opacity: 1.0

                function zeroPad(num,count) {
                    var numZeropad = num + '';
                    while(numZeropad.length < count) {
                        numZeropad = "0" + numZeropad;
                    }
                    return numZeropad;
                }

                function updateDateBySelection() {
                    //console.debug("updateDateBySelection")

                    var newDTS = ""

                    if (xaqmldatepicker.enabled) {
                        newDTS = zeroPad(xaqmldatepicker.theYear, 4) + "-" + zeroPad(xaqmldatepicker.theMonth, 2) + "-" + zeroPad(xaqmldatepicker.theDay, 2);
                        newDTS += " " + xaqmldatepicker.theTime

                        newDTS += " +0000"

                        //console.debug("YEAR: " + xaqmldatepicker.theYear)
                        //console.debug("MONTH: " + xaqmldatepicker.theMonth)
                        //console.debug("DAY: " + xaqmldatepicker.theDay)

                        newDTS = zeroPad(xaqmldatepicker.theYear, 4) + "-" + zeroPad(xaqmldatepicker.theMonth, 2) + "-" + zeroPad(xaqmldatepicker.theDay, 2);
                        newDTS += " " + zeroPad(xaqmldatepicker.theTime.substring(0,2), 2) + ":" + zeroPad(xaqmldatepicker.theTime.substring(3,5), 2) + ":00";

                        //var d = new Date(xaqmldatepicker.theYear, xaqmldatepicker.theMonth, xaqmldatepicker.theDay, xaqmldatepicker.theTime.substring(0,2), xaqmldatepicker.theTime.substring(3,5), 0, 0)
                        var d = new Date()
                        //console.debug(d)

                        //newDTS = zeroPad(d.getFullYear(), 4) + "-" + zeroPad(d.getMonth(), 2) + "-" + zeroPad(d.getDate(), 2);
                        //newDTS += " " + zeroPad(d.getHours(), 2) + ":" + zeroPad(d.getMinutes(), 2) + ":00"

                        var off = d.getTimezoneOffset()
                        var gmtHours

                        if (off < 0) { newDTS += " +"; gmtHours = -d.getTimezoneOffset()/60; }
                        else { newDTS += " -"; gmtHours = d.getTimezoneOffset()/60; }

                        newDTS += zeroPad(gmtHours, 2) + "00"
                    }

                    console.debug("newDTS:" + newDTS)

                    if (activeInputFieldID == 1) {
                        //framedTextInputReviewDate.text = newDTS
                        //QtHandler.ReviewDataChangedForField("review_dt", framedTextInputReviewDate.text)
                        QtHandler.ReviewDataChangedForField("review_dt", newDTS)
                    }

                    if (activeInputFieldID == 2) {
                        //                framedTextInputStartDate.text = newDTS
                        //                QtHandler.ReviewDataChangedForField("start_dt", framedTextInputStartDate.text)
                        QtHandler.ReviewDataChangedForField("start_dt", newDTS)
                    }

                    if (activeInputFieldID == 4) {
                        //                framedTextInputDueDate.text = newDTS
                        //                QtHandler.ReviewDataChangedForField("end_dt", framedTextInputDueDate.text)
                        QtHandler.ReviewDataChangedForField("end_dt", newDTS)
                    }
                }

                function updateRepeatStringResultBySelection() {
                    //console.debug("updateRepeatStringResultBySelection")
                    //console.debug(xaqmlrepeatdatepicker.dtsRepeatChanged)
                    QtHandler.ReviewDataChangedForField("repeat", xaqmlrepeatdatepicker.dtsRepeatChanged)

                    //framedTextInputRepeatDate.text = xaqmlrepeatdatepicker.dtsRepeatChanged
                }

                function updateDurationBySelection() {
                    //console.debug("updateDurationBySelection")

                    var newDTS = ""

                    if (xaqmldurationpicker.enabled) {
                        newDTS = zeroPad(xaqmldurationpicker.theDays, 3) + ":" + zeroPad(xaqmldurationpicker.theHours, 2) + ":" + zeroPad(xaqmldurationpicker.theMinutes, 2);
                    }

                    //console.debug("newDTS:" + newDTS)

                    QtHandler.ReviewDataChangedForField("duration", newDTS)
                }

                XAQMLDatePicker1 {
                    id: xaqmldatepicker
                    anchors.top: parent.top
                    anchors.left: parent.left
                    anchors.right: parent.right
                    enabled: true
                    visible: false

                    onDateSelected: if (!fieldChange) parent.updateDateBySelection()
                }

                XAQMLRepeatDatePicker {
                    id: xaqmlrepeatdatepicker
                    x: 0
                    y: 0
                    width: 250
                    height: 364
                    anchors.topMargin: -47
                    transformOrigin: Item.Center

                    anchors.top: parent.top
                    anchors.centerIn: parent

                    enabled: true
                    visible: false

                    onRepeatStringResultUpdated: if (!fieldChange) parent.updateRepeatStringResultBySelection()
                }

                XAQMLDurationPicker {
                    id: xaqmldurationpicker
                    anchors.top: parent.top
                    anchors.left: parent.left
                    anchors.right: parent.right
                    enabled: true
                    visible: false

                    onDurationSelected: if (!fieldChange) parent.updateDurationBySelection()
                }

                XAQMLAddressBookPicker {
                    id: xaqmladdressbookpicker
//                    x: 0
//                    y: 0
                    width: 250
                    height: 364
                    anchors.topMargin: -47
                    transformOrigin: Item.Center

                    anchors.top: parent.top
                    anchors.centerIn: parent
                    enabled: true
                    visible: false

                    onEntrySelectionChanged: {
                        contextAssignmentChanged();
                    }
                }
            }
        }

        Item {
            id: tabInternalDetailsEditor
            anchors.fill: parent

            //
            // TITLE: Internal Object
            //

            Text {
                id: titleInternalObject_labelShadow
                //anchors.fill: parent

                anchors.horizontalCenter: parent.horizontalCenter
                anchors.verticalCenter: parent.verticalCenter
                anchors.verticalCenterOffset: 1

                text: "No item selected."
                color: "black"
                font.family: "Arial"
                //font.pointSize: 14
                font.pixelSize: 14
                font.bold: true
                smooth: true
            }

            Text {
                id: titleInternalObject_label
                //anchors.fill: parent

                anchors.horizontalCenter: parent.horizontalCenter
                anchors.verticalCenter: parent.verticalCenter

                text: "No item selected."
                color: "white"
                font.family: "Arial"
                //font.pointSize: 14
                font.pixelSize: 14
                font.bold: true
                smooth: true
            }
        }

        Component.onCompleted: {
            displayedItemTypeChanged();
        }
    }
}
